Qwt User's Guide: QwtPanner Class Reference

Qwt User's Guide 6.3.0

Loading...
Searching...
No Matches
Signals | Public Member Functions | Protected Member Functions | List of all members
QwtPanner Class Reference

QwtPanner provides panning of a widget. More...

`#include <qwt_panner.h>`

Inheritance diagram for QwtPanner:

## Signals
void | panned (int dx, int dy)
void | moved (int dx, int dy)

## Public Member Functions
| QwtPanner (QWidget *parent)
virtual | ~QwtPanner ()
| Destructor.
void | setEnabled (bool)
| En/disable the panner.
bool | isEnabled () const
void | setMouseButton (Qt::MouseButton, Qt::KeyboardModifiers=Qt::NoModifier)
void | getMouseButton (Qt::MouseButton &button, Qt::KeyboardModifiers &) const
| Get mouse button and modifiers used for panning.
void | setAbortKey (int key, Qt::KeyboardModifiers=Qt::NoModifier)
void | getAbortKey (int &key, Qt::KeyboardModifiers &) const
| Get the abort key and modifiers.
void | setCursor (const QCursor &)
const QCursor | cursor () const
void | setOrientations (Qt::Orientations)
Qt::Orientations | orientations () const
| Return the orientation, where panning is enabled.
bool | isOrientationEnabled (Qt::Orientation) const
virtual bool | eventFilter (QObject *, QEvent *) override
| Event filter.

## Protected Member Functions
virtual void | widgetMousePressEvent (QMouseEvent *)
virtual void | widgetMouseReleaseEvent (QMouseEvent *)
virtual void | widgetMouseMoveEvent (QMouseEvent *)
virtual void | widgetKeyPressEvent (QKeyEvent *)
virtual void | widgetKeyReleaseEvent (QKeyEvent *)
virtual void | paintEvent (QPaintEvent *) override
| Paint event.
virtual QBitmap | contentsMask () const
| Calculate a mask for the contents of the panned widget.
virtual QPixmap | grab () const

## Detailed Description

QwtPanner provides panning of a widget.

QwtPanner grabs the contents of a widget, that can be dragged in all directions. The offset between the start and the end position is emitted by the panned signal.

QwtPanner grabs the content of the widget into a pixmap and moves the pixmap around, without initiating any repaint events for the widget. Areas, that are not part of content are not painted while panning. This makes panning fast enough for widgets, where repaints are too slow for mouse movements.

For widgets, where repaints are very fast it might be better to implement panning manually by mapping mouse events into paint events.

Definition at line 35 of file qwt_panner.h.

## Constructor & Destructor Documentation

## ◆ QwtPanner()

QwtPanner::QwtPanner | ( | QWidget * | parent | ) |
| explicit

Creates an panner that is enabled for the left mouse button.

Parameters

  parent | Parent widget to be panned

Definition at line 87 of file qwt_panner.cpp.

## ◆ ~QwtPanner()

QwtPanner::~QwtPanner | ( |  | ) |
| virtual

Destructor.

Definition at line 101 of file qwt_panner.cpp.

## Member Function Documentation

## ◆ contentsMask()

QBitmap QwtPanner::contentsMask | ( |  | ) | const
| protectedvirtual

Calculate a mask for the contents of the panned widget.

Sometimes only parts of the contents of a widget should be panned. F.e. for a widget with a styled background with rounded borders only the area inside of the border should be panned.

Returns
  An empty bitmap, indicating no mask

Reimplemented in QwtPlotPanner.

Definition at line 297 of file qwt_panner.cpp.

## ◆ cursor()

const QCursor QwtPanner::cursor | ( |  | ) | const

Returns
  Cursor that is active while panning

See also
  setCursor()

Definition at line 167 of file qwt_panner.cpp.

## ◆ eventFilter()

bool QwtPanner::eventFilter | ( | QObject * | object,
|  | QEvent * | event )
| overridevirtual

Event filter.

When isEnabled() is true mouse events of the observed widget are filtered.

Parameters

  object | Object to be filtered
  event | Event

Returns
  Always false, beside for paint events for the parent widget.

See also
  widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseMoveEvent()

Definition at line 330 of file qwt_panner.cpp.

## ◆ getAbortKey()

void QwtPanner::getAbortKey | ( | int & | key,
|  | Qt::KeyboardModifiers & | modifiers ) const

Get the abort key and modifiers.

Definition at line 140 of file qwt_panner.cpp.

## ◆ getMouseButton()

void QwtPanner::getMouseButton | ( | Qt::MouseButton & | button,
|  | Qt::KeyboardModifiers & | modifiers ) const

Get mouse button and modifiers used for panning.

Definition at line 118 of file qwt_panner.cpp.

## ◆ grab()

QPixmap QwtPanner::grab | ( |  | ) | const
| protectedvirtual

Grab the widget into a pixmap.

Returns
  Grabbed pixmap

Reimplemented in QwtPlotPanner.

Definition at line 306 of file qwt_panner.cpp.

## ◆ isEnabled()

bool QwtPanner::isEnabled | ( |  | ) | const

Returns
  true when enabled, false otherwise

See also
  setEnabled, eventFilter()

Definition at line 240 of file qwt_panner.cpp.

## ◆ isOrientationEnabled()

bool QwtPanner::isOrientationEnabled | ( | Qt::Orientation | o | ) | const

Returns
  True if an orientation is enabled

See also
  orientations(), setOrientations()

Definition at line 231 of file qwt_panner.cpp.

## ◆ moved

void QwtPanner::moved | ( | int | dx,
|  | int | dy )
| signal

Signal emitted, while the widget moved, but panning is not finished.

Parameters

  dx | Offset in horizontal direction
  dy | Offset in vertical direction

## ◆ orientations()

Qt::Orientations QwtPanner::orientations | ( |  | ) | const

Return the orientation, where panning is enabled.

Definition at line 222 of file qwt_panner.cpp.

## ◆ paintEvent()

void QwtPanner::paintEvent | ( | QPaintEvent * | event | ) |
| overrideprotectedvirtual

Paint event.

Repaint the grabbed pixmap on its current position and fill the empty spaces by the background of the parent widget.

Parameters

  event | Paint event

Definition at line 253 of file qwt_panner.cpp.

## ◆ panned

void QwtPanner::panned | ( | int | dx,
|  | int | dy )
| signal

Signal emitted, when panning is done

Parameters

  dx | Offset in horizontal direction
  dy | Offset in vertical direction

## ◆ setAbortKey()

void QwtPanner::setAbortKey | ( | int | key,
|  | Qt::KeyboardModifiers | modifiers = Qt::NoModifier )

Change the abort key The defaults are Qt::Key_Escape and Qt::NoModifiers

Parameters

  key | Key ( See Qt::Keycode )
  modifiers | Keyboard modifiers

Definition at line 132 of file qwt_panner.cpp.

## ◆ setCursor()

void QwtPanner::setCursor | ( | const QCursor & | cursor | ) |

Change the cursor, that is active while panning The default is the cursor of the parent widget.

Parameters

  cursor | New cursor

See also
  setCursor()

Definition at line 156 of file qwt_panner.cpp.

## ◆ setEnabled()

void QwtPanner::setEnabled | ( | bool | on | ) |

En/disable the panner.

When enabled is true an event filter is installed for the observed widget, otherwise the event filter is removed.

Parameters

  on | true or false

See also
  isEnabled(), eventFilter()

Definition at line 188 of file qwt_panner.cpp.

## ◆ setMouseButton()

void QwtPanner::setMouseButton | ( | Qt::MouseButton | button,
|  | Qt::KeyboardModifiers | modifiers = Qt::NoModifier )

Change the mouse button and modifiers used for panning The defaults are Qt::LeftButton and Qt::NoModifier

Definition at line 110 of file qwt_panner.cpp.

## ◆ setOrientations()

void QwtPanner::setOrientations | ( | Qt::Orientations | o | ) |

Set the orientations, where panning is enabled The default value is in both directions: Qt::Horizontal | Qt::Vertical

/param o Orientation

Definition at line 216 of file qwt_panner.cpp.

## ◆ widgetKeyPressEvent()

void QwtPanner::widgetKeyPressEvent | ( | QKeyEvent * | keyEvent | ) |
| protectedvirtual

Handle a key press event for the observed widget.

Parameters

  keyEvent | Key event

See also
  eventFilter(), widgetKeyReleaseEvent()

Definition at line 482 of file qwt_panner.cpp.

## ◆ widgetKeyReleaseEvent()

void QwtPanner::widgetKeyReleaseEvent | ( | QKeyEvent * | keyEvent | ) |
| protectedvirtual

Handle a key release event for the observed widget.

Parameters

  keyEvent | Key event

See also
  eventFilter(), widgetKeyReleaseEvent()

Definition at line 502 of file qwt_panner.cpp.

## ◆ widgetMouseMoveEvent()

void QwtPanner::widgetMouseMoveEvent | ( | QMouseEvent * | mouseEvent | ) |
| protectedvirtual

Handle a mouse move event for the observed widget.

Parameters

  mouseEvent | Mouse event

See also
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent()

Definition at line 421 of file qwt_panner.cpp.

## ◆ widgetMousePressEvent()

void QwtPanner::widgetMousePressEvent | ( | QMouseEvent * | mouseEvent | ) |
| protectedvirtual

Handle a mouse press event for the observed widget.

Parameters

  mouseEvent | Mouse event

See also
  eventFilter(), widgetMouseReleaseEvent(), widgetMouseMoveEvent(),

Reimplemented in QwtPolarPanner.

Definition at line 381 of file qwt_panner.cpp.

## ◆ widgetMouseReleaseEvent()

void QwtPanner::widgetMouseReleaseEvent | ( | QMouseEvent * | mouseEvent | ) |
| protectedvirtual

Handle a mouse release event for the observed widget.

Parameters

  mouseEvent | Mouse event

See also
  eventFilter(), widgetMousePressEvent(), widgetMouseMoveEvent(),

Definition at line 449 of file qwt_panner.cpp.